/*
  Name: car.cpp
  Copyright: Polecatsoft 2005
  Author: Master Lenman
  Date: 14.08.05 18:12
  Description: The car is a very hard enemy type:
			It follows you and tries to hit you
  Game: 24h of Le Merde
*/

#include "StdAfx.h"
#include "enemy.h"
#include "car.h"

BITMAP *cargfx = 0;

enemycar::enemycar()
{
	if(!cargfx)
	    cargfx = load_bitmap("gfx/enemycar.tga", 0);
	if(!cargfx)
		error::loadBit("gfx/enemycar.tga");
	damaged = false;
	posX = 0 - cargfx->w;
	posY = rand() % (SCREEN_H - 9 - (cargfx->h >> 1));
	time = 16 * 17; //8.5 seconds
}

//Move has to return the number of life points the player should lose
int enemycar::move(int playerPosX, int playerPosY, int playerWidth, int playerHeight)
{
	if(!time)
	{
		posX -= 3;
	}
	else
	{
		if(playerPosY > posY)
		    ++posY;
		else if(playerPosY < posY)
			--posY;

		if(playerPosX > posX)
			++posX;
		else if(playerPosX < posX)
			--posX;
		if(collides(playerPosX, playerPosY, playerWidth, playerHeight >> 1, cargfx->w, cargfx->h >> 1))
		{
			damaged = true;
			time = 0;
		    return 12;
		}
		--time;
	}
	return 0;
}

//If this method returns true, the object needs to be destroyed
bool enemycar::finished()
{
	return !time && (posX + cargfx->w) <= 0;
}

//This method should simply draw the enemy
void enemycar::draw()
{
	masked_blit(cargfx, global::dbuffer, 0, 0, posX, posY - (cargfx->h >> 1), cargfx->w, cargfx->h);
}

//If the player uses his attack, this method is called
void enemycar::attack(int playerPosX, int playerPosY, int playerWidth, int playerHeight)
{
	if(collides(playerPosX, playerPosY, playerWidth, playerHeight >> 1, cargfx->w, cargfx->h >> 1))
	{
		damaged = true;
		time = 0;
	}
}
