/*
  Name: enemy.h
  Copyright: Polecatsoft 2005
  Author: Master Lenman
  Date: 14.08.05 17:30
  Description: The pure virtual base class for all enemy types
  Game: 24h of Le Merde
*/

#include "StdAfx.h"
#include "enemy.h"

bool enemy::collides(int playerPosX, int playerPosY, int playerWidth, int playerHeight, int enemyWidth, int enemyHeight)
{
	bool collides[4] = { false, false, false, false };

	//Left side colliding
	if(playerPosX <= posX + enemyWidth && playerPosX >= posX)
	{
		collides[0] = true;
	}
	//Right side colliding
	if(playerPosX + playerWidth >= posX && playerPosX + playerWidth <= posX + enemyWidth)
	{
		collides[1] = true;
	}
	//Top side colliding
	if(playerPosY - playerHeight <= posY + enemyHeight && playerPosY - playerHeight >= posY - enemyHeight)
	{
		collides[2] = true;
	}
	//Bottom side colliding
	if(playerPosY + playerHeight >= posY - enemyHeight && playerPosY + playerHeight <= posY + enemyHeight)
	{
		collides[3] = true;
	}

	if(!(collides[0] || collides[1] || collides[2] || collides[3]))
		return false;

	//Check total collision for all 4 corners
	if(collides[0] && collides[2])
		return true;
	if(collides[0] && collides[3])
		return true;
	if(collides[1] && collides[2])
		return true;
	if(collides[1] && collides[3])
		return true;

	if(playerHeight > enemyHeight)
	{
		if((collides[0] || collides[1]) && playerPosY - playerHeight < posY - enemyHeight && playerPosY + playerHeight > posY + enemyHeight)
			return true;
	}
	if(playerWidth > enemyWidth)
	{
		if((collides[2] || collides[3]) && playerPosX < posX && playerPosX + playerWidth > posX + enemyWidth)
			return true;
	}

	return false;
}
