/*
  Name: enemy.h
  Copyright: Polecatsoft 2005
  Author: Master Lenman
  Date: 14.08.05 16:34
  Description: The pure virtual base class for all enemy types
  Game: 24h of Le Merde
*/

#ifndef ENEMY_H
#define ENEMY_H

class enemy
{
protected:
	//Position
	int posX, posY;
	//Every enemy is only allowed to damage the player once
	bool damaged;
	
	//checks if the unit collides with the player
	bool collides(int playerPosX, int playerPosY, int playerWidth, int playerHeight, int enemyWidth, int enemyHeight);
public:
	//Move has to return the number of life points the player should lose
	virtual int move(int playerPosX, int playerPosY, int playerWidth, int playerHeight) = 0;
	//If this method returns true, the object needs to be destroyed
	virtual bool finished() = 0;
	//This method should simply draw the enemy
	virtual void draw() = 0;
	//If the player uses his attack, this method is called
	virtual void attack(int playerPosX, int playerPosY, int playerWidth, int playerHeight) = 0;

	inline int getPosX() { return posX; }
	inline int getPosY() { return posY; }
};

#endif
