/*
  Name: errors.cpp
  Copyright: Polecatsoft 2005
  Author: Master Lenman
  Date: 11.08.05 14:43
  Description: A namespace containing all kinds of error messages
  Game: SH '05 template
*/

#include "StdAfx.h"
#include <string>
using namespace std;

//Error function that can be used for virtually everything
void error::fatal(const string message)
{
	set_gfx_mode(GFX_TEXT, 0,0,0,0);
    allegro_message(message.c_str());
    exit(0);
}

//If Timer wasn't initialised
void error::timer()
{
	fatal("Error001: Timer could not be initialised");
}

//If there's no keyboard driver
void error::keyboard()
{
	fatal("Error002: No keyboarddriver found");
}

//No sounddriver found
void error::soundDriver()
{
	fatal("Error003: Sound driver could not be initialised");
}

//If no graphicmode could be entered
void error::graphicMode()
{
	fatal("Error004: Graphic mode couldn't be set");
}

//create_bitmap failed
void error::create()
{
	fatal("Error005: Creating bitmap failed");
}

//load_bitmap failed
void error::loadBit(const string name)
{
	fatal(string("Error006: Loading bitmap \"") + name + string("\" failed"));
}

//load_datafile failed
void error::datafile(const string name)
{
	fatal(string("Error007: Loading datafile \"") + name + string("\" failed"));
}

//loading a sound file failed
void error::sampleLoad(const string sampleName)
{
	fatal(string("Error008: Loading sample \"") + sampleName + string("\" failed"));
}

//Division by 0
void error::divBy0(const string module)
{
	allegro_message((string("Error009: A division by 0 error was prevented in the following modul:\n") + module).c_str());
}
