/*
  Name: errors.h
  Copyright: Polecatsoft 2005
  Author: Master Lenman
  Date: 11.08.05 14:40
  Description: A namespace containing all kinds of error messages
  Game: SH '05 template
*/

#ifndef ERRORS_H
#define ERRORS_H

#include <string>

namespace error
{
	//Error function that can be used for virtually everything
	void fatal(const std::string message);

	//If Timer wasn't initialised
	void timer();

	//If there's no keyboard driver
	void keyboard();

	//No sounddriver found
	void soundDriver();

	//If no graphicmode could be entered
	void graphicMode();

	//create_bitmap failed
	void create();

	//load_bitmap failed
	void loadBit(const std::string name);

	//load_datafile failed
	void datafile(const std::string name);

	//loading a sound file failed
	void sampleLoad(const std::string sampleName);

	//Division by 0
	void divBy0(const std::string module);
}

#endif
