/*
  Name: robot.h
  Copyright: Polecatsoft 2005
  Author: Master Lenman
  Date: 14.08.05 20:31
  Description: The robot will randomly move left and right and shoot
            bullets every 4 seconds
  Game: 24h of Le Merde
*/

#ifndef ROBOT_H
#define ROBOT_H

extern BITMAP *robotgfx, *robotbullet;
extern sound robotshoot;

class robot : public enemy
{
private:
	//posX and posY are used for the bullet, so we need another pair of coords
	int rPosX, rPosY;
	int time;
	int mtime;
	int dir;
public:
	//Standard constructor
	robot();
	//Move has to return the number of life points the player should lose
	int move(int playerPosX, int playerPosY, int playerWidth, int playerHeight);
	//If this method returns true, the object needs to be destroyed
	bool finished();
	//This method should simply draw the enemy
	void draw();
	//If the player uses his attack, this method is called
	void attack(int playerPosX, int playerPosY, int playerWidth, int playerHeight);
};

#endif
