/*
  Name: stone.cpp
  Copyright: Polecatsoft 2005
  Author: Master Lenman
  Date: 14.08.05 17:09
  Description: Contains an enemy type: The stone.
            The stone will just fly through the screen.
  Game: 24h of Le Merde
*/

#include "StdAfx.h"
#include "enemy.h"
#include "stone.h"

BITMAP *gfx = NULL;

stone::stone()
{
	if(!gfx)
	    gfx = load_bitmap("gfx/stone.tga", 0);
	if(!gfx)
		error::loadBit("gfx/stone.tga");
	damaged = false;
	posX = SCREEN_W - gfx->w;
	posY = rand() % (SCREEN_H - 9 - (gfx->h >> 1));
}

void stone::draw()
{
	masked_blit(gfx, global::dbuffer, 0, 0, posX, posY - (gfx->h >> 1), gfx->w, gfx->h);
}

bool stone::finished()
{
	return (posX + gfx->w) <= 0;
}

int stone::move(int playerPosX, int playerPosY, int playerWidth, int playerHeight)
{
	posX -= 4;
	if(!damaged && collides(playerPosX, playerPosY, playerWidth, playerHeight >> 1, gfx->w, gfx->h >> 1))
	{
		damaged = true;
	    return 4;
	}
	return 0;
}

//If the player uses his attack, this method is called
void stone::attack(int playerPosX, int playerPosY, int playerWidth, int playerHeight)
{
	//Stones are immune against attacks
}
